/*
    This example demonstrates an use developped by me functions SPEEDFLT for
 optimization of performing a command LOCATE FOR...
    Program creates test.dbf file from 5000 record and 2 subscripted files
 test1 and test2.
    Global variable 'prspeed' is used in FINDREC functions() for including/
 switching off an optimization.
    Assigning condition for the searching DPOLE fields and NPOLE, on which
 built indexes, you convince, what advantage in velocities gives an
 optimization. For instance:
 dpole=ctod("01/01/93") ,
 npole=684510

 If will be questions, offers - write on E-Mail.
 Good luck.
 Alexander Kresin.
 alex@belacy.belgorod.su
*/
#include "optim.ch"
LOCAL fname, expstr, sctime, sum1
PUBLIC prspeed

   ? "Example to the report 'Optimization of requests...'"
   expstr = Space( 40 )
   IF File( "test.dbf" )
      USE test INDEX test1, test2
   ELSE
      ? "Wait, is created file test.dbf"
      CR_BD()
   ENDIF
   cho = "1"
   DO WHILE cho <> "0"
      ? "1. Searching with the optimization"
      ? "2. Searching without optimization"
      ? "3. SUM with the optimization"
      ? "4. SUM without optimization"
      ? "5. Browse"
      ? "0. EXIT"
      ?
      WAIT "YOUR CHOICE:" TO cho
      DO CASE
      CASE cho = "1" .OR. cho = "2"
         ?
         @ 24, 0 SAY "Input expression:" GET expstr PICTURE "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
         READ
         prspeed = iif( cho = "1", .T. , .F. )
         sctime = Seconds()
         LOCATE FOR expstr
         sctime = Seconds() - sctime
         ?
         ? "Record ", iif( &expstr, "found", "not found" )
         ? "LOCATE has perfected for ", sctime, " seconds"
      CASE cho = "3" .OR. cho = "4"
         ?
         @ 24, 0 SAY "Input expression:" GET expstr PICTURE "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
         READ
         prspeed = iif( cho = "3", .T. , .F. )
         sctime = Seconds()
         SUM NPOLE TO sum1 FOR expstr
         sctime = Seconds() - sctime
         ?
         ? "Amount =", sum1
         ? "SUM has perfected for ", sctime, " seconds"
      CASE cho = "5"
         Browse()
         @ 0, 0 CLEAR TO 24, 79
      ENDCASE
   ENDDO

   RETURN

FUNCTION FINDREC( expfnd )

   IF prspeed .AND. SPEEDFLT( expfnd ) // If request is optimized,
      dbSeek( stseek )        // search first record, partly satisfying
   ELSE                   // condition, otherwise -
      GO TOP                // searching beginning of file
      stusl = ".T."
   ENDIF
   DO WHILE .NOT. Eof() .AND. &stusl
      IF &expfnd
         EXIT // Suit record is found!
      ENDIF
      SKIP
   ENDDO

   RETURN Nil

FUNCTION SUMREC( bSum, expfnd )

   IF prspeed .AND. SPEEDFLT( expfnd ) // If request is optimized,
      dbSeek( stseek )     // search first record, partly satisfying
   ELSE                // condition, otherwise -
      GO TOP             // searching beginning of file
      stusl = ".T."
   ENDIF
   DO WHILE .NOT. Eof() .AND. &stusl
      IF &expfnd
         Eval( bSum )
      ENDIF
      SKIP
   ENDDO

   RETURN Nil

FUNCTION SPEEDFLT( expflt )

   LOCAL rez := .F. , iord := 0, ; // Openning index Counter
   ielem, elemf, ellen, elemzn, poz, poz1, poz2, poz3, exptmp, expind

   PUBLIC stseek, ;      // Will Here be formed key for command SEEK
      stusl               // but here - condition of completion of sample

   STORE "" TO stseek, stusl
   DO WHILE .NOT. rez
      iord ++         // Increment openning index counter
#ifdef RDD_NTX   // if they are used by NTX - indexes
      expind = Upper( IndexKey( iord ) )
#else            // if CDX, MDX and others.
      expind = Upper( OrdKey( iord ) )
#endif

      IF Empty( expind ) // If more no openned indexes - to finish scanning,
         EXIT
      ELSE             // otherwise - to begin analysis of subscripted expression
         DO WHILE .NOT. Empty ( expind )
            poz = At( "+", expind )
            IF poz <> 0
               ielem = SubStr( expind, 1, poz - 1 )
               poz = poz + 1
               expind = SubStr( expind, poz )
            ELSE
               ielem = expind
               expind = ""
            ENDIF
            poz1 = At( "(", ielem ) // Presence of functions define on presence "("

            IF poz1 = 0
               elemf = ielem // If its no, the name of field == expression element
            ELSE
               elemf = SubStr( ielem, poz1 + 1 )
               poz2 = At( ",", elemf )
               IF poz2 = 0
                  poz2 = At( ")", elemf )
               ENDIF
               IF poz2 <> 0
                  elemf = SubStr( elemf, 1, poz2 - 1 )
               ENDIF
            ENDIF

            ellen = Len( elemf ) // Get length of name of field
            poz2 = At( elemf, Upper( expflt ) )

            IF poz2 > 0 .AND. SubStr( expflt, poz2 + ellen, 1 ) = "="
               IF At( elemf, Upper( SubStr(expflt,poz2 + ellen + 1 ) ) ) = 0
                  rez = .T.
                  elemzn = SubStr( expflt, poz2 + ellen + 1 )
                  poz2 = At( ".", elemzn )
                  IF poz2 <> 0 .AND. IsDigit( SubStr( elemzn,poz2 + 1 ) )
                     poz3 = At( ".", SubStr( elemzn,poz2 + 1 ) )
                     poz2 = poz2 + iif( poz3 = 0, 999, poz3 - 1 )
                  ENDIF

                  elemzn = SubStr( elemzn, 1, iif( poz2 = 0,999,poz2 - 1 ) )
                  stusl = stusl + iif( Empty( stusl ), "", ".AND." ) + elemf + "=" + elemzn
                  exptmp = Stuff( ielem, poz1 + 1, ellen, elemzn )
                  stseek = stseek + &exptmp
               ENDIF
            ENDIF
            IF .NOT. ( elemf $ stusl )
               EXIT
            ENDIF
         ENDDO
      ENDIF
   ENDDO

   IF rez
#ifdef RDD_NTX
      SET ORDER TO iord
#else
      OrdSetFocus( iord )
#endif
   ENDIF

   RETURN rez

FUNCTION CR_BD

   LOCAL i, j, date1, n1, s1, s2

   CREATE test_st
   USE test_st
   APPEND BLANK
   REPLACE FIELD_NAME WITH "CPOLE", FIELD_TYPE WITH "C", FIELD_LEN WITH 20
   APPEND BLANK
   REPLACE FIELD_NAME WITH "DPOLE", FIELD_TYPE WITH "D"
   APPEND BLANK
   REPLACE FIELD_NAME WITH "NPOLE", FIELD_TYPE WITH "N", FIELD_LEN WITH 15
   APPEND BLANK
   REPLACE FIELD_NAME WITH "CPOLE2", FIELD_TYPE WITH "C", FIELD_LEN WITH 60
   USE
   CREATE test FROM test_st
   ERASE test_st.dbf
   USE test
   INDEX ON Dtos( DPOLE ) TO test1
   INDEX ON Str( NPOLE, 15 ) TO test2
   SET INDEX TO test1, test2
   date1 = CToD( "01/01/90" )
   s1 = "ABCDEFGHIJKLMNOPRSTU"
   s2 = s1
   FOR i = 1 TO 5000
      APPEND BLANK
      n1 = Seconds()
      REPLACE CPOLE WITH s2, DPOLE WITH date1, NPOLE WITH Int( n1 * ( n1 - Int(n1 ) ) * 100 ), ;
         CPOLE2 WITH s2 + s2
      date1 = date1 + 1
      IF Year( date1 ) = 1996
         date1 = CToD( "01/01/90" )
      ENDIF
      s1 = s2
      s2 = ""
      FOR j = 1 TO 20
         s2 = s2 + iif( SubStr( s1,j,1 ) < "z", Chr( Asc(SubStr(s1,j,1 ) ) + 1 ), "A" )
      NEXT
   NEXT
   GO TOP

   RETURN Nil
